/////////////////////////////////////
//  Generated Initialization File  //
/////////////////////////////////////

#include "compiler_defs.h"
#include "SI_C8051F360_Register_Enums.h"
#include "Project_DefsVarsFuncs.h"

// Peripheral specific initialization functions,
// Called from the Init_Device() function
void PCA_Init()
{
    PCA0CN    = 0x40;
    PCA0MD    = 0x08;
    PCA0CPM0  = 0x46;
    //PCA0CPH0  = 0x64;	//500 kHz sample rate
    //PCA0CPH0  = 0x19;		//2 MHz sample rate
    PCA0CPH0  = 0x0F;		//3,333,333 MHz sample rate
}

void Timer_Init()
{
    TCON      = 0x41;
    TMOD      = 0x20;
    CKCON     = 0x01;
    TH1       = 0xBF;
    TMR2CN    = 0x01;
}

void UART_Init()
{
    SCON0     = 0x10;
}

void Voltage_Reference_Init()
{
    REF0CN    = 0x02;
}

void Port_IO_Init()
{
    // P0.0  -  Skipped,     Open-Drain, Digital
    // P0.1  -  TX0 (UART0), Push-Pull,  Digital
    // P0.2  -  RX0 (UART0), Open-Drain, Digital
    // P0.3  -  Skipped,     Open-Drain, Analog
    // P0.4  -  Skipped,     Open-Drain, Digital
    // P0.5  -  Skipped,     Open-Drain, Digital
    // P0.6  -  Skipped,     Open-Drain, Digital
    // P0.7  -  CEX0  (PCA), Push-Pull,  Digital

    // P1.0  -  Unassigned,  Open-Drain, Digital
    // P1.1  -  Unassigned,  Open-Drain, Digital
    // P1.2  -  Unassigned,  Open-Drain, Digital
    // P1.3  -  Unassigned,  Open-Drain, Digital
    // P1.4  -  Unassigned,  Open-Drain, Digital
    // P1.5  -  Unassigned,  Open-Drain, Digital
    // P1.6  -  Unassigned,  Open-Drain, Analog
    // P1.7  -  Unassigned,  Push-Pull,  Digital

    // P2.0  -  Unassigned,  Push-Pull,  Digital
    // P2.1  -  Unassigned,  Push-Pull,  Digital
    // P2.2  -  Unassigned,  Push-Pull,  Digital
    // P2.3  -  Unassigned,  Push-Pull,  Digital
    // P2.4  -  Unassigned,  Push-Pull,  Digital
    // P2.5  -  Unassigned,  Push-Pull,  Digital
    // P2.6  -  Unassigned,  Push-Pull,  Digital
    // P2.7  -  Unassigned,  Push-Pull,  Digital

    // P3.0  -  Unassigned,  Open-Drain, Digital
    // P3.1  -  Unassigned,  Open-Drain, Digital
    // P3.2  -  Unassigned,  Open-Drain, Digital
    // P3.3  -  Unassigned,  Open-Drain, Digital
    // P3.4  -  Unassigned,  Open-Drain, Digital
    // P3.5  -  Unassigned,  Open-Drain, Digital
    // P3.6  -  Unassigned,  Open-Drain, Digital
    // P3.7  -  Unassigned,  Open-Drain, Digital

    SFRPAGE   = CONFIG_PAGE;
    P0MDIN    = 0xF7;
    P1MDIN    = 0xBF;
    P0MDOUT   = 0x82;
    P1MDOUT   = 0x80;
    P2MDOUT   = 0xFF;
    P4MDOUT   = 0x1C;
    P0SKIP    = 0x79;
    XBR0      = 0x01;
    XBR1      = 0x41;
}

void Oscillator_Init()
{
    int i = 0;
    SFRPAGE   = CONFIG_PAGE;
    OSCXCN    = 0x20;
    PLL0CN    = 0x04;
    CCH0CN    &= ~0x20;
    SFRPAGE   = LEGACY_PAGE;
    FLSCL     = 0x30;
    SFRPAGE   = CONFIG_PAGE;
    CCH0CN    |= 0x20;
    PLL0CN    |= 0x01;
    PLL0DIV   = 0x01;
    PLL0FLT   = 0x07;
    PLL0MUL   = 0x0A;
    for (i = 0; i < 15; i++);  // Wait 5us for initialization
    PLL0CN    |= 0x02;
    while ((PLL0CN & 0x10) == 0);
    CLKSEL    = 0x04;
}

void Interrupts_Init()
{
    SFRPAGE   = CONFIG_PAGE;
    IT01CF    = 0x07;
    IE        = 0x11;
}

// Initialization function for device,
// Call Init_Device() from your main program
void Init_Device(void)
{
    PCA_Init();
    Timer_Init();
    UART_Init();
    Voltage_Reference_Init();
    Port_IO_Init();
    Oscillator_Init();
    Interrupts_Init();
}
