
//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <SI_C8051F360_Register_Enums.h>                // SFR declarations
#include "Project_DefsVarsFuncs.h"

//-----------------------------------------------------------------------------
// main() Routine
// ----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
/*int main (void)
{
	unsigned int n = 0;

	PCA0MD &= ~BIT6;	//disable watchdog timer

	Init_Device();

	P4 = 0x00;
	DAC_SLEEP = 0;
	DAC_WORD = 0;

	for(n=0; n<DACDATA_LEN; n++)
	{
		DACdata_RAM[n] = DACdata_128SPP[n];
	}

	IE_EA = 1;	//enable interrupts

	while(1);
}*/

int main (void)
{
	unsigned int n = 0;

	PCA0MD &= ~BIT6;	//disable watchdog timer

	Init_Device();

	IE_EA = 0;	//ensure that interrupts are disabled

	P4 = 0x00;
	DAC_SLEEP = 0;
	DAC_WORD = 0;

	for(n=0; n<DACDATA_LEN; n++)
	{
		DACdata_RAM[n] = DACdata_128SPP[n];
	}

	while(1)
	{
		if(TCON_IE0)
		{
			TCON_IE0 = 0;

			DAC_WORD = DACdata_RAM[DACdata_index_8bit];
			DACdata_index_8bit++;
		}
	}
}
